Authen::Passphrase::EggdropBlowfish(3)

NAME
Authen::Passphrase::EggdropBlowfish - passphrases using Eggdrop's blowfish.mod

SYNOPSIS
        use Authen::Passphrase::EggdropBlowfish;

        $ppr = Authen::Passphrase::EggdropBlowfish->new(
                hash_base64 => "9tpsG/61YqX/");

        $ppr = Authen::Passphrase::EggdropBlowfish->new(
                passphrase => "passphrase");

        $hash = $ppr->hash;
        $hash_base64 = $ppr->hash_base64;

        if($ppr->match($passphrase)) { ...

DESCRIPTION
An object of this class encapsulates a passphrase hashed using the Blowfish-based algorithm used in Eggdrop's blowfish.mod. This is a subclass of Authen::Passphrase, and this document assumes that the reader is familiar with the documentation for that class.

This hash scheme uses no salt, and does not accept a zero-length passphrase. It uses the passphrase as a Blowfish key to encrypt a standard plaintext block. The hash is the ciphertext block. The standard Blowfish key schedule only accepts keys from 8 to 56 bytes long; this algorithm relaxes that requirement and accepts any non-zero length. Up to 72 bytes of passphrase/key are significant; any more are ignored.

In Eggdrop the hash is represented as a "+" followed by twelve base 64 digits. The first six digits encode the second half of the hash, and the last six encode the first half. Within each half the bytes are encoded in reverse order. The base 64 digits are ".", "/", "0" to "9", "a" to "z", "A" to "Z" (in that order).

Warning: The hash is small by modern standards, and the lack of salt is a weakness in this scheme. For a scheme that makes better use of Blowfish see Authen::Passphrase::BlowfishCrypt.

CONSTRUCTOR

Authen::Passphrase::EggdropBlowfish->new(ATTR => VALUE, ...)
    Generates a new passphrase recogniser object using the Eggdrop blowfish.mod algorithm. The following attributes may be given:

    hash
        The hash, as a string of eight bytes.

    hash_base64
        The hash, as a string of twelve base 64 digits.

    passphrase
        A passphrase that will be accepted.

    Either the hash or the passphrase must be given.

METHODS

$ppr->hash
    Returns the hash value, as a string of eight bytes.

$ppr->hash_base64
    Returns the hash value, as a string of twelve base 64 digits.

$ppr->match(PASSPHRASE)
    This method is part of the standard Authen::Passphrase interface.

SEE ALSO
Authen::Passphrase, Crypt::Eksblowfish::Uklblowfish

AUTHOR
Andrew Main (Zefram) <zefram@fysh.org>

COPYRIGHT
Copyright (C) 2006, 2007, 2009, 2010, 2012 Andrew Main (Zefram) <zefram@fysh.org>

LICENSE
This module is free software; you can redistribute it and/or modify it under the same terms as Perl itself.